/*	Copyright  2001 The Regents of the University of California.
*	All Rights Reserved.
*	Permission to use, copy, modify, and distribute this software and its
*	documentation for educational, research and non-profit purposes, without
*	fee, and without a written agreement is hereby granted, provided that the
*	above copyright notice, this paragraph and the following three paragraphs
*	appear in all copies.
*	Permission to incorporate this software into commercial products may
*	be obtained by contacting the University of California: 
*	Bill Hoskins
*	Office of Technology Licensing
*	2150 Shattuck Avenue #150
* 	Berkeley, CA 94720-1620
*	(510) 643-7201
*	bhoskins@uclink2.berkeley.edu
*	
*
*	This software program and documentation are copyrighted by The Regents
*	of the University of California. The software program and documentation
*	are supplied "as is", without any accompanying services from
*	The Regents. The Regents does not warrant that the operation of the program
*	will be uninterrupted or error-free. The end-user understands that the
*	program was developed for research purposes and is advised not to rely
*	exclusively on the program for any reason.
*	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
*	FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
*	LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION,
*	EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY
*	OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY
*	WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
*	AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
*	ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO
*	OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*	This software is based on Mark Fullmer's flow-tools 
*	http://www.splintered.net/sw/flow-tools/
*	$Id: route_lookup.h,v 1.2 2001/10/17 23:32:24 robert Exp $
*/
#include <sys/time.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/file.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fcntl.h>
#include <mrt.h>
#include <bgp.h>
#include <bgp_proto.h>
#include <user.h>
#include <rip.h>
//#include <pim.h>
//#include <dvmrp.h>
#include <config_file.h>
#include <protoconf.h>
#include <version.h>
#include <timer.h>
#include <trace.h>
#include <community.h>
#include "bytes.h"
/* mrt declarations */

  
  
/* read in  bgpdump file into routing table */
void load_file (char* rib_file);

/*lookup aspath for given prefix */
/* returns 0 on success (path in aspath_string) */
/* -1 on failure */
char* lookup_aspath(u_int32 prefix, u_int8 mask_bitlen);


/*lookup community string  for given prefix */
/* returns 0 on success (string in community_string) */
/* -1 on failure */
char* lookup_community(u_int32 prefix, u_int8 mask_bitlen);

/*clean up */
int fin();
  
